/*
 * The Kibitz - Internal Stuff
 *
 * (c) 2005-2012 Tomas Valla <tom@ucw.cz>
 *
 * This software may be freely distributed and used according to the terms
 * of the GNU Lesser General Public License. See COPYING for details.
 */

#ifndef _KIBITZ_INTERNAL_H_
#define _KIBITZ_INTERNAL_H_

#include <kibitz/kibitz.h>
#include <kibitz/index.h>

#define DUMP(x...) fprintf(stderr, x)

#define HARD_MAX_WORD_LEN	256
#define HARD_MAX_PHRASE_LEN	4096
#define HARD_FASTFIND_ITEMS	50
#define HARD_QUERY_MAX_RESULTS	50

struct config {
	char *indexer_log_file;
	uns indexer_verbose;
	uns min_word_len;
	uns max_word_len;
	uns min_phrase_len;
	uns max_phrase_len;
	uns fastfind_threshold;
	uns fastfind_items;
	uns default_wordref_buf_size;

	double exact_match_bonus;
	double single_word_bonus;
	double phrase_bonus;

	uns query_max_results;

	char *httpd_status_file;
	char *httpd_log_file;
	uns log_connections;
	uns listen_queue;
	uns request_timeout;
	uns response_timeout;
	uns httpd_port;
};

extern struct config config;

struct result {
	struct phrase *phrase;
	int quality;
};

uns search_index(byte *word, uns wlen, struct result *res, uns max_res);
void wordref_add(uns wstart, uns wlen);

#endif
